﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace Log_File_Remover
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            listBoxRemoved.Items.Clear();
            listBoxUnremovable.Items.Clear();
            progressBar.Style = ProgressBarStyle.Marquee;
            btnStart.Visible = false;
            chkStrictRemoval.Enabled = false;
            logRemover.RunWorkerAsync(chkStrictRemoval.Checked);
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            logRemover.CancelAsync();
        }

        private void logRemover_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            // Result is a multi-demensional array,
            // The first array is the removable filePaths
            // The second is the unremovable filePaths
            string[][] filePathSet = (string[][])e.Result;
            listBoxRemoved.SuspendLayout();
            listBoxRemoved.Items.AddRange(filePathSet[0]);
            listBoxRemoved.ResumeLayout();
            listBoxUnremovable.SuspendLayout();
            listBoxUnremovable.Items.AddRange(filePathSet[1]);
            listBoxUnremovable.ResumeLayout();

            lblRemoved.Text = listBoxRemoved.Items.Count.ToString() + " Removed:";
            lblUnremovable.Text = listBoxUnremovable.Items.Count.ToString() + " Unremovable:";
            // Disable progress animation
            progressBar.Style = ProgressBarStyle.Blocks;
            chkStrictRemoval.Enabled = true;
            btnStart.Visible = true;
        }

        private void listBoxUnremovable_DoubleClick(object sender, EventArgs e)
        {
            if (listBoxUnremovable.SelectedItem != null)
            {
                try
                {
                    Process.Start(listBoxUnremovable.SelectedItem.ToString());
                }
                catch (Exception ex)
                {
                    string message = "Unable to open file!\n" + ex.Message;
                    MessageBox.Show(message, Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }
    }
}
